diff -Naur src.pgsql/include/catalog/pg_amop.h src.bizgres/include/catalog/pg_amop.h
--- src.pgsql/include/catalog/pg_amop.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/catalog/pg_amop.h	2006-07-17 22:33:05.000000000 -0700
@@ -876,4 +876,57 @@
 DATA(insert (	2780	0 3  t  2752 ));
 DATA(insert (	2780	0 4  t	1070 ));
 
+/*
+ * the operators for the on-disk bitmap index.
+ */
+DATA(insert (	2849	0 1 f  560 ));	/* abstime */
+DATA(insert (	2850	0 1 f 1070 ));	/* array */
+DATA(insert (	2851	0 1 f 1784 ));	/* bit */
+DATA(insert (	2852	0 1 f	91 ));	/* bool */
+DATA(insert (	2853	0 1 f 1054 ));	/* bpchar */
+DATA(insert (	2854	0 1 f 1955 ));	/* bytea */
+DATA(insert (	2855	0 1 f	92 ));	/* char */
+DATA(insert (	2856	0 1 f  820 ));	/* cidr */
+DATA(insert (	2857	0 1 f 1093 ));	/* date */
+DATA(insert (	2857 1114 1 f 2347 ));	/* date-timestamp */
+DATA(insert (	2857 1184 1 f 2360 ));	/* date-timestamptz */
+DATA(insert (	2858	0 1 f  620 ));	/* float4 */
+DATA(insert (	2858  701 1 f 1120 ));	/* float48 */
+DATA(insert (	2859	0 1 f  670 ));	/* float8 */
+DATA(insert (	2859  700 1 f 1130 ));	/* float84 */
+DATA(insert (	2860	0 1 f 1201 ));	/* inet */
+DATA(insert (	2861	0 1 f	94 ));	/* int2 */
+DATA(insert (	2861   23 1 f  532 ));	/* int24 */
+DATA(insert (	2861   20 1 f 1862 ));	/* int28 */
+DATA(insert (	2862	0 1 f	96 ));	/* int4 */
+DATA(insert (	2862   21 1 f  533 ));	/* int42 */
+DATA(insert (	2862   20 1 f	15 ));	/* int48 */
+DATA(insert (	2863	0 1 f  410 ));	/* int8 */
+DATA(insert (	2863   21 1 f 1868 ));	/* int82 */
+DATA(insert (	2863   23 1 f  416 ));	/* int84 */
+DATA(insert (	2864	0 1 f 1330 ));	/* interval */
+DATA(insert (	2865	0 1 f 1220 ));	/* macaddr */
+DATA(insert (	2866	0 1 f	93 ));	/* name */
+DATA(insert (	2867	0 1 f 1752 ));	/* numeric */
+DATA(insert (	2868	0 1 f  607 ));	/* oid */
+DATA(insert (	2869	0 1 f  649 ));	/* oidvector */
+DATA(insert (	2870	0 1 f	98 ));	/* text */
+DATA(insert (	2871	0 1 f 1108 ));	/* time */
+DATA(insert (	2872	0 1 f 1320 ));	/* timestamptz */
+DATA(insert (	2872 1082 1 f 2386 ));	/* timestamptz-date */
+DATA(insert (	2872 1114 1 f 2542 ));	/* timestamptz-timestamp */
+DATA(insert (	2873	0 1 f 1550 ));	/* timetz */
+DATA(insert (	2874	0 1 f 1804 ));	/* varbit */
+DATA(insert (	2875	0 1 f	98 ));	/* varchar */
+DATA(insert (	2876	0 1 f 2060 ));	/* timestamp */
+DATA(insert (	2876 1082 1 f 2373 ));	/* timestamp-date */
+DATA(insert (	2876 1184 1 f 2536 ));	/* timestamp-timestamptz */
+DATA(insert (	2877	0 1 f 2316 ));	/* text pattern */
+DATA(insert (	2878	0 1 f 2316 ));	/* varchar pattern */
+DATA(insert (	2879	0 1 f 2328 ));	/* bpchar pattern */
+DATA(insert (	2880	0 1 f 2334 ));	/* name pattern */
+DATA(insert (	2881	0 1 f  900 ));	/* money */
+DATA(insert (	2882	0 1 f  566 ));	/* reltime */
+DATA(insert (	2883	0 1 f  811 ));	/* tinterval */
+
 #endif   /* PG_AMOP_H */
diff -Naur src.pgsql/include/catalog/pg_amproc.h src.bizgres/include/catalog/pg_amproc.h
--- src.pgsql/include/catalog/pg_amproc.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/catalog/pg_amproc.h	2006-07-17 22:33:05.000000000 -0700
@@ -307,4 +307,58 @@
 DATA(insert (	2780	0 3 2743 ));
 DATA(insert (	2780	0 4 2744 ));
 
+/*
+ * the operator routines for the on-disk bitmap index.
+ */
+DATA(insert (	2849	0 1 2833 ));	/* abstime */
+DATA(insert (	2850	0 1 2834 ));	/* array */
+DATA(insert (	2851	0 1 1596 ));	/* bit */
+DATA(insert (	2852	0 1 2824 ));	/* bool */
+DATA(insert (	2853	0 1 1078 ));	/* bpchar */
+DATA(insert (	2854	0 1 1954 ));	/* bytea */
+DATA(insert (	2855	0 1 2825 ));	/* char */
+DATA(insert (	2856	0 1  926 ));	/* cidr */
+DATA(insert (	2857	0 1 1092 ));	/* date */
+DATA(insert (	2857 1114 1 2344 ));	/* date-timestamp */
+DATA(insert (	2857 1184 1 2357 ));	/* date-timestamptz */
+DATA(insert (	2858	0 1 2839 ));	/* float4 */
+DATA(insert (	2858  701 1 2842 ));	/* float48 */
+DATA(insert (	2859	0 1 2840 ));	/* float8 */
+DATA(insert (	2859  700 1 2843 ));	/* float84 */
+DATA(insert (	2860	0 1  926 ));	/* inet */
+DATA(insert (	2861	0 1 2821 ));	/* int2 */
+DATA(insert (	2861   23 1 2828 ));	/* int24 */
+DATA(insert (	2861   20 1 2830 ));	/* int28 */
+DATA(insert (	2862	0 1 2822 ));	/* int4 */
+DATA(insert (	2862   20 1 2829 ));	/* int42 */
+DATA(insert (	2862   21 1 2826 ));	/* int48 */
+DATA(insert (	2863	0 1 2823 ));	/* int8 */
+DATA(insert (	2863   21 1 2831 ));	/* int82 */
+DATA(insert (	2863   23 1 2827 ));	/* int84 */
+DATA(insert (	2864	0 1 1315 ));	/* interval */
+DATA(insert (	2865	0 1  836 ));	/* macaddr */
+DATA(insert (	2866	0 1 2837 ));	/* name */
+DATA(insert (	2867	0 1 1769 ));	/* numeric */
+DATA(insert (	2868	0 1 2835 ));	/* oid */
+DATA(insert (	2869	0 1 2836 ));	/* oidvector */
+DATA(insert (	2870	0 1 2832 ));	/* text */
+DATA(insert (	2871	0 1 1107 ));	/* time */
+DATA(insert (	2872	0 1 1314 ));	/* timestamptz */
+DATA(insert (	2872 1082 1 2383 ));	/* timestamptz-date */
+DATA(insert (	2872 1114 1 2533 ));	/* timestamptz-timestamp */
+DATA(insert (	2873	0 1 1358 ));	/* timetz */
+DATA(insert (	2874	0 1 1672 ));	/* varbit */
+DATA(insert (	2875	0 1 2832 ));	/* varchar */
+DATA(insert (	2876	0 1 2045 ));	/* timestamp */
+DATA(insert (	2876 1082 1 2370 ));	/* timestamp-date */
+DATA(insert (	2876 1184 1 2526 ));	/* timestamp-timestamptz */
+DATA(insert (	2877	0 1 2837 ));	/* text pattern */
+DATA(insert (	2878	0 1 2166 ));	/* varchar pattern */
+DATA(insert (	2879	0 1 2847 ));	/* bpchar pattern */
+DATA(insert (	2880	0 1 2838 ));	/* name pattern */
+DATA(insert (	2881	0 1  377 ));	/* money */
+DATA(insert (	2882	0 1 2844 ));	/* reltime */
+DATA(insert (	2883	0 1 2845 ));	/* tinterval */
+
+
 #endif   /* PG_AMPROC_H */
diff -Naur src.pgsql/include/catalog/pg_opclass.h src.bizgres/include/catalog/pg_opclass.h
--- src.pgsql/include/catalog/pg_opclass.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/catalog/pg_opclass.h	2006-07-17 22:33:05.000000000 -0700
@@ -207,4 +207,43 @@
 DATA(insert OID = 2779 (	2742	_reltime_ops	PGNSP PGUID  1024 t 703 ));
 DATA(insert OID = 2780 (	2742	_tinterval_ops	PGNSP PGUID  1025 t 704 ));
 
+/*
+ * the operators for the on-disk bitmap index.
+ */
+DATA(insert OID = 2849 (	2848	abstime_ops		PGNSP PGUID  702 t 0 ));
+DATA(insert OID = 2850 (	2848	array_ops		PGNSP PGUID 2277 t 0 ));
+DATA(insert OID = 2851 (	2848	bit_ops			PGNSP PGUID 1560 t 0 ));
+DATA(insert OID = 2852 (	2848	bool_ops		PGNSP PGUID   16 t 0 ));
+DATA(insert OID = 2853 (	2848	bpchar_ops		PGNSP PGUID 1042 t 0 ));
+DATA(insert OID = 2854 (	2848	bytea_ops		PGNSP PGUID   17 t 0 ));
+DATA(insert OID = 2855 (	2848	char_ops		PGNSP PGUID   18 t 0 ));
+DATA(insert OID = 2856 (	2848	cidr_ops		PGNSP PGUID  650 t 0 ));
+DATA(insert OID = 2857 (	2848	date_ops		PGNSP PGUID 1082 t 0 ));
+DATA(insert OID = 2858 (	2848	float4_ops		PGNSP PGUID  700 t 0 ));
+DATA(insert OID = 2859 (	2848	float8_ops		PGNSP PGUID  701 t 0 ));
+DATA(insert OID = 2860 (	2848	inet_ops		PGNSP PGUID  869 t 0 ));
+DATA(insert OID = 2861 (	2848	int2_ops		PGNSP PGUID   21 t 0 ));
+DATA(insert OID = 2862 (	2848	int4_ops        PGNSP PGUID   23 t 0 ));
+DATA(insert OID = 2863 (	2848	int8_ops		PGNSP PGUID   20 t 0 ));
+DATA(insert OID = 2864 (	2848	interval_ops	PGNSP PGUID 1186 t 0 ));
+DATA(insert OID = 2865 (	2848	macaddr_ops		PGNSP PGUID  829 t 0 ));
+DATA(insert OID = 2866 (	2848	name_ops		PGNSP PGUID   19 t 0 ));
+DATA(insert OID = 2867 (	2848	numeric_ops		PGNSP PGUID 1700 t 0 ));
+DATA(insert OID = 2868 (	2848	oid_ops			PGNSP PGUID   26 t 0 ));
+DATA(insert OID = 2869 (	2848	oidvector_ops	PGNSP PGUID   30 t 0 ));
+DATA(insert OID = 2870 (	2848	text_ops		PGNSP PGUID   25 t 0 ));
+DATA(insert OID = 2871 (	2848	time_ops		PGNSP PGUID 1083 t 0 ));
+DATA(insert OID = 2872 (	2848	timestamptz_ops PGNSP PGUID 1184 t 0 ));
+DATA(insert OID = 2873 (	2848	timetz_ops		PGNSP PGUID 1266 t 0 ));
+DATA(insert OID = 2874 (	2848	varbit_ops		PGNSP PGUID 1562 t 0 ));
+DATA(insert OID = 2875 (	2848	varchar_ops		PGNSP PGUID 1043 t 0 ));
+DATA(insert OID = 2876 (	2848	timestamp_ops	PGNSP PGUID 1114 t 0 ));
+DATA(insert OID = 2877 (	2848	text_pattern_ops	PGNSP PGUID   25 f 0 ));
+DATA(insert OID = 2878 (	2848	varchar_pattern_ops PGNSP PGUID 1043 f 0 ));
+DATA(insert OID = 2879 (	2848	bpchar_pattern_ops	PGNSP PGUID 1042 f 0 ));
+DATA(insert OID = 2880 (	2848	name_pattern_ops	PGNSP PGUID   19 f 0 ));
+DATA(insert OID = 2881 (	2848	money_ops		PGNSP PGUID  790 t 0 ));
+DATA(insert OID = 2882 (	2848	reltime_ops		PGNSP PGUID  703 t 0 ));
+DATA(insert OID = 2883 (	2848	tinterval_ops	PGNSP PGUID  704 t 0 ));
+
 #endif   /* PG_OPCLASS_H */
diff -Naur src.pgsql/include/catalog/pg_proc.h src.bizgres/include/catalog/pg_proc.h
--- src.pgsql/include/catalog/pg_proc.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/catalog/pg_proc.h	2006-07-17 22:33:05.000000000 -0700
@@ -3872,6 +3872,65 @@
 DATA(insert OID = 2749 (  arraycontained	   PGNSP PGUID 12 f f t f i 2 16 "2277 2277" _null_ _null_ _null_ arraycontained - _null_ ));
 DESCR("anyarray contained");
 
+/* the bitmap index access method routines */
+DATA(insert OID = 2801 (  bmgettuple		   PGNSP PGUID 12 f f t f v 2 16 "2281 2281" _null_ _null_ _null_  bmgettuple - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2802 (  bmgetmulti		   PGNSP PGUID 12 f f t f v 4 16 "2281 2281 2281 2281" _null_ _null_ _null_  bmgetmulti - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2599 (  bmgetbitmapwords	   PGNSP PGUID 12 f f t f v 5 16 "2281 2281 2281 2281 2281" _null_  _null_ _null_ bmgetbitmapwords - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2803 (  bminsert		   PGNSP PGUID 12 f f t f v 6 16 "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_	bminsert - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2804 (  bmbeginscan	   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 2281" _null_ _null_ _null_	bmbeginscan - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2805 (  bmrescan		   PGNSP PGUID 12 f f t f v 2 2278 "2281 2281" _null_ _null_ _null_	bmrescan - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2806 (  bmendscan		   PGNSP PGUID 12 f f t f v 1 2278 "2281" _null_ _null_ _null_	bmendscan - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2807 (  bmmarkpos		   PGNSP PGUID 12 f f t f v 1 2278 "2281" _null_ _null_ _null_	bmmarkpos - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2808 (  bmrestrpos		   PGNSP PGUID 12 f f t f v 1 2278 "2281" _null_ _null_ _null_	bmrestrpos - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2809 (  bmbuild		   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 2281" _null_ _null_ _null_ bmbuild - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2810 (  bmbulkdelete	   PGNSP PGUID 12 f f t f v 4 2281 "2281 2281 2281 2281" _null_ _null_ _null_ bmbulkdelete - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2811 (  bmvacuumcleanup   PGNSP PGUID 12 f f t f v 2 2281 "2281 2281" _null_ _null_ _null_ bmvacuumcleanup - _null_ ));
+DATA(insert OID = 2812 (  bmcostestimate   PGNSP PGUID 12 f f t f v 8 2278 "2281 2281 2281 2281 2281 2281 2281 2281" _null_ _null_ _null_  bmcostestimate - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2813 (  bmoptions		   PGNSP PGUID 12 f f t f s 2 17 "1009 16" _null_ _null_ _null_  bmoptions - _null_ ));
+DESCR("btree(internal)");
+
+/* the operators for the bitmap index */
+DATA(insert OID = 2821 (  bmint2cmp			PGNSP PGUID 12 f f t f i 2 23 "21 21" _null_ _null_ _null_ bmint2cmp - _null_ ));
+DATA(insert OID = 2822 (  bmint4cmp			PGNSP PGUID 12 f f t f i 2 23 "23 23" _null_ _null_ _null_ bmint4cmp - _null_ ));
+DATA(insert OID = 2823 (  bmint8cmp			PGNSP PGUID 12 f f t f i 2 23 "20 20" _null_ _null_ _null_ bmint8cmp - _null_ ));
+DATA(insert OID = 2824 (  bmboolcmp			PGNSP PGUID 12 f f t f i 2 23 "16 16" _null_ _null_ _null_ bmboolcmp - _null_ ));
+DATA(insert OID = 2825 (  bmcharcmp			PGNSP PGUID 12 f f t f i 2 23 "18 18" _null_ _null_ _null_ bmcharcmp - _null_ ));
+ 
+DATA(insert OID = 2826 (  bmint48cmp		PGNSP PGUID 12 f f t f i 2 23 "23 20" _null_ _null_ _null_ bmint48cmp - _null_ ));
+DATA(insert OID = 2827 (  bmint84cmp		PGNSP PGUID 12 f f t f i 2 23 "20 23" _null_ _null_ _null_ bmint84cmp - _null_ ));
+DATA(insert OID = 2828 (  bmint24cmp		PGNSP PGUID 12 f f t f i 2 23 "21 23" _null_ _null_ _null_ bmint24cmp - _null_ ));
+DATA(insert OID = 2829 (  bmint42cmp		PGNSP PGUID 12 f f t f i 2 23 "23 21" _null_ _null_ _null_ bmint42cmp - _null_ ));
+DATA(insert OID = 2830 (  bmint28cmp		PGNSP PGUID 12 f f t f i 2 23 "21 20" _null_ _null_ _null_ bmint28cmp - _null_ ));
+DATA(insert OID = 2831 (  bmint82cmp		PGNSP PGUID 12 f f t f i 2 23 "20 21" _null_ _null_ _null_ bmint82cmp - _null_ ));
+ 
+DATA(insert OID = 2832 (  bmtextcmp			PGNSP PGUID 12 f f t f i 2 23 "25 25" _null_ _null_ _null_ bmtextcmp - _null_ ));
+DATA(insert OID = 2833 (  bmabstimecmp		PGNSP PGUID 12 f f t f i 2 23 "702 702"  _null_ _null_ _null_ bmabstimecmp - _null_ ));
+DATA(insert OID = 2834 (  bmarraycmp		PGNSP PGUID 12 f f t f i 2 23 "2277 2277"  _null_ _null_ _null_ bmarraycmp - _null_ ));
+DATA(insert OID = 2835 (  bmoidcmp			PGNSP PGUID 12 f f t f i 2 23 "26 26"  _null_ _null_ _null_ bmoidcmp - _null_ ));
+DATA(insert OID = 2836 (  bmoidvectorcmp	PGNSP PGUID 12 f f t f i 2 23 "30 30"  _null_ _null_ _null_ bmoidvectorcmp - _null_ ));
+DATA(insert OID = 2837 (  bmnamecmp			PGNSP PGUID 12 f f t f i 2 23 "19 19"  _null_ _null_ _null_ bmnamecmp - _null_ ));
+DATA(insert OID = 2838 (  bmname_pattern_cmp	PGNSP PGUID 12 f f t f i 2 23 "19 19"  _null_ _null_ _null_ bmname_pattern_cmp - _null_ ));
+DATA(insert OID = 2839 (  bmfloat4cmp		PGNSP PGUID 12 f f t f i 2 23 "700 700"  _null_ _null_ _null_ bmfloat4cmp - _null_ ));
+DATA(insert OID = 2840 (  bmfloat8cmp		PGNSP PGUID 12 f f t f i 2 23 "701 701"  _null_ _null_ _null_ bmfloat8cmp - _null_ ));
+DATA(insert OID = 2842 (  bmfloat48cmp		PGNSP PGUID 12 f f t f i 2 23 "700 701" _null_ _null_ _null_ bmfloat48cmp - _null_ ));
+DATA(insert OID = 2843 (  bmfloat84cmp		PGNSP PGUID 12 f f t f i 2 23 "701 700"  _null_ _null_ _null_ bmfloat84cmp - _null_ ));
+DATA(insert OID = 2844 (  bmreltimecmp		PGNSP PGUID 12 f f t f i 2 23 "703 703"  _null_ _null_ _null_ bmreltimecmp - _null_ ));
+DATA(insert OID = 2845 (  bmtintervalcmp    PGNSP PGUID 12 f f t f i 2 23 "704 704"  _null_ _null_ _null_ bmtintervalcmp - _null_ ));
+DATA(insert OID = 2846 (  bmtext_pattern_cmp	PGNSP PGUID 12 f f t f i 2 23 "25 25"  _null_ _null_ _null_ bmtext_pattern_cmp - _null_ ));
+DATA(insert OID = 2847 (  bmbpchar_pattern_cmp	PGNSP PGUID 12 f f t f i 2 23 "1042 1042"  _null_ _null_ _null_ bmtext_pattern_cmp - _null_ ));
+
 /*
  * Symbolic values for provolatile column: these indicate whether the result
  * of a function is dependent *only* on the values of its explicit arguments,
diff -Naur src.pgsql/include/nodes/execnodes.h src.bizgres/include/nodes/execnodes.h
--- src.pgsql/include/nodes/execnodes.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/nodes/execnodes.h	2006-07-17 22:33:05.000000000 -0700
@@ -18,6 +18,7 @@
 #include "nodes/params.h"
 #include "nodes/plannodes.h"
 #include "nodes/tidbitmap.h"
+#include "nodes/ondiskbitmapwords.h"
 #include "utils/hsearch.h"
 #include "utils/tuplestore.h"
 
@@ -843,6 +844,8 @@
 	PlanState	ps;				/* its first field is NodeTag */
 	PlanState **bitmapplans;	/* array of PlanStates for my inputs */
 	int			nplans;			/* number of input plans */
+	OnDiskBitmapWords **odbms;	/* OnDiskBitmapWords for each input */
+	OnDiskBitmapWords *resultOdbm;	/* the output OnDiskBitmapWords */
 } BitmapAndState;
 
 /* ----------------
@@ -854,6 +857,8 @@
 	PlanState	ps;				/* its first field is NodeTag */
 	PlanState **bitmapplans;	/* array of PlanStates for my inputs */
 	int			nplans;			/* number of input plans */
+	OnDiskBitmapWords **odbms;	/* OnDiskBitmapWords for each input */
+	OnDiskBitmapWords *resultOdbm;	/* the output OnDiskBitmapWords */
 } BitmapOrState;
 
 /* ----------------------------------------------------------------
@@ -958,6 +963,7 @@
 {
 	ScanState	ss;				/* its first field is NodeTag */
 	TIDBitmap  *biss_result;
+	OnDiskBitmapWords *odbiss_result;
 	ScanKey		biss_ScanKeys;
 	int			biss_NumScanKeys;
 	IndexRuntimeKeyInfo *biss_RuntimeKeys;
@@ -968,6 +974,7 @@
 	ExprContext *biss_RuntimeContext;
 	Relation	biss_RelationDesc;
 	IndexScanDesc biss_ScanDesc;
+	IndexScanDesc odbiss_ScanDesc;
 } BitmapIndexScanState;
 
 /* ----------------
@@ -983,7 +990,9 @@
 	ScanState	ss;				/* its first field is NodeTag */
 	List	   *bitmapqualorig;
 	TIDBitmap  *tbm;
+	OnDiskBitmapWords	*odbm;
 	TBMIterateResult *tbmres;
+	BMIterateResult *odbmres;
 } BitmapHeapScanState;
 
 /* ----------------
diff -Naur src.pgsql/include/nodes/nodes.h src.bizgres/include/nodes/nodes.h
--- src.pgsql/include/nodes/nodes.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/nodes/nodes.h	2006-07-17 22:33:05.000000000 -0700
@@ -332,7 +332,9 @@
 	 */
 	T_TriggerData = 900,		/* in commands/trigger.h */
 	T_ReturnSetInfo,			/* in nodes/execnodes.h */
-	T_TIDBitmap					/* in nodes/tidbitmap.h */
+	T_TIDBitmap,				/* in nodes/tidbitmap.h */
+	T_OnDiskBitmapWords			/* in nodes/ondiskbitmapwords.h */
+	
 } NodeTag;
 
 /*
diff -Naur src.pgsql/include/nodes/ondiskbitmapwords.h src.bizgres/include/nodes/ondiskbitmapwords.h
--- src.pgsql/include/nodes/ondiskbitmapwords.h	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/include/nodes/ondiskbitmapwords.h	2006-07-17 22:33:05.000000000 -0700
@@ -0,0 +1,46 @@
+/*-------------------------------------------------------------------------
+ *
+ * ondiskbitmapwords.h
+ *
+ * Define data structures that handle the bitmap words in the
+ * on-disk bitmap index.
+ *
+ * 	PostgreSQL
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ * IDENTIFICATION
+ *	$PostgreSQL$
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef ONDISKBITMAPWORDS_H
+#define ONDISKBITMAPWORDS_H
+
+#include "nodes/plannodes.h"
+#include "access/bitmap.h"
+
+struct PlanState;
+
+
+/*
+ * A node that contains a batch of bitmap words in a bitmap vector.
+ */
+typedef struct OnDiskBitmapWords
+{
+	NodeTag			type; 				/* to make it a valid Node */
+	MemoryContext 	mcxt;			/* memory context containing me */
+	BMBatchWords	bitmapWords;	/* a batch of bitmap words */
+} OnDiskBitmapWords;
+
+/* function prototypes in nodes/ondiskbitmapwords.c */
+extern OnDiskBitmapWords* odbm_create(uint32 maxNumOfWords);
+extern void odbm_free(OnDiskBitmapWords *odbm);
+extern BMIterateResult* odbm_res_create(OnDiskBitmapWords *odbm);
+extern void odbm_res_free(BMIterateResult* odbmres);
+
+extern void odbm_set_bitmaptype(Plan* plan, bool inmem);
+extern void odbm_set_child_resultnode(struct PlanState* ps, 
+									  OnDiskBitmapWords* odbm);
+
+#endif /* ONDISKBITMAPWORDS_H */
diff -Naur src.pgsql/include/nodes/plannodes.h src.bizgres/include/nodes/plannodes.h
--- src.pgsql/include/nodes/plannodes.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/nodes/plannodes.h	2006-07-17 22:33:05.000000000 -0700
@@ -144,6 +144,7 @@
 {
 	Plan		plan;
 	List	   *bitmapplans;
+	bool		inmem;			/* use bitmap scan */
 } BitmapAnd;
 
 /* ----------------
@@ -158,6 +159,7 @@
 {
 	Plan		plan;
 	List	   *bitmapplans;
+	bool		inmem;			/* use bitmap scan */
 } BitmapOr;
 
 /*
@@ -209,6 +211,7 @@
 	List	   *indexstrategy;	/* integer list of strategy numbers */
 	List	   *indexsubtype;	/* OID list of strategy subtypes */
 	ScanDirection indexorderdir;	/* forward or backward or don't care */
+	Oid			indexam;			/* OID of the access method (in pg_am) */
 } IndexScan;
 
 /* ----------------
@@ -232,10 +235,12 @@
 {
 	Scan		scan;
 	Oid			indexid;		/* OID of index to scan */
+	Oid			indexam;		/* OID of the access method (in pg_am) */
 	List	   *indexqual;		/* list of index quals (OpExprs) */
 	List	   *indexqualorig;	/* the same in original form */
 	List	   *indexstrategy;	/* integer list of strategy numbers */
 	List	   *indexsubtype;	/* OID list of strategy subtypes */
+	bool		inmem; 			/* use bitmap scan */
 } BitmapIndexScan;
 
 /* ----------------
@@ -251,6 +256,7 @@
 {
 	Scan		scan;
 	List	   *bitmapqualorig; /* index quals, in standard expr form */
+	bool		inmem; 			/* use bitmap scan */
 } BitmapHeapScan;
 
 /* ----------------
diff -Naur src.pgsql/include/utils/array.h src.bizgres/include/utils/array.h
--- src.pgsql/include/utils/array.h	2006-07-17 17:05:17.000000000 -0700
+++ src.bizgres/include/utils/array.h	2006-07-17 22:33:06.000000000 -0700
@@ -193,6 +193,7 @@
 extern Datum array_le(PG_FUNCTION_ARGS);
 extern Datum array_ge(PG_FUNCTION_ARGS);
 extern Datum btarraycmp(PG_FUNCTION_ARGS);
+extern Datum bmarraycmp(PG_FUNCTION_ARGS);
 extern Datum array_dims(PG_FUNCTION_ARGS);
 extern Datum array_lower(PG_FUNCTION_ARGS);
 extern Datum array_upper(PG_FUNCTION_ARGS);
diff -Naur src.pgsql/include/utils/builtins.h src.bizgres/include/utils/builtins.h
--- src.pgsql/include/utils/builtins.h	2006-07-17 17:05:18.000000000 -0700
+++ src.bizgres/include/utils/builtins.h	2006-07-17 22:33:06.000000000 -0700
@@ -886,4 +886,31 @@
 /* utils/mmgr/portalmem.c */
 extern Datum pg_cursor(PG_FUNCTION_ARGS);
 
+/* comparison functions for the bitmap index. */
+extern Datum bmint4cmp(PG_FUNCTION_ARGS);
+extern Datum bmint2cmp(PG_FUNCTION_ARGS);
+extern Datum bmint8cmp(PG_FUNCTION_ARGS);
+extern Datum bmint48cmp(PG_FUNCTION_ARGS);
+extern Datum bmint84cmp(PG_FUNCTION_ARGS);
+extern Datum bmint24cmp(PG_FUNCTION_ARGS);
+extern Datum bmint42cmp(PG_FUNCTION_ARGS);
+extern Datum bmint28cmp(PG_FUNCTION_ARGS);
+extern Datum bmint82cmp(PG_FUNCTION_ARGS);
+extern Datum bmboolcmp(PG_FUNCTION_ARGS);
+extern Datum bmcharcmp(PG_FUNCTION_ARGS);
+extern Datum bmtextcmp(PG_FUNCTION_ARGS);
+extern Datum bmabstimecmp(PG_FUNCTION_ARGS);
+extern Datum bmarraycmp(PG_FUNCTION_ARGS);
+extern Datum bmoidcmp(PG_FUNCTION_ARGS);
+extern Datum bmoidvectorcmp(PG_FUNCTION_ARGS);
+extern Datum bmnamecmp(PG_FUNCTION_ARGS);
+extern Datum bmname_pattern_cmp(PG_FUNCTION_ARGS);
+extern Datum bmfloat4cmp(PG_FUNCTION_ARGS);
+extern Datum bmfloat8cmp(PG_FUNCTION_ARGS);
+extern Datum bmfloat48cmp(PG_FUNCTION_ARGS);
+extern Datum bmfloat84cmp(PG_FUNCTION_ARGS);
+extern Datum bmreltimecmp(PG_FUNCTION_ARGS);
+extern Datum bmtintervalcmp(PG_FUNCTION_ARGS);
+extern Datum bmtext_pattern_cmp(PG_FUNCTION_ARGS);
+
 #endif   /* BUILTINS_H */
diff -Naur src.pgsql/include/utils/rel.h src.bizgres/include/utils/rel.h
--- src.pgsql/include/utils/rel.h	2006-07-17 17:05:18.000000000 -0700
+++ src.bizgres/include/utils/rel.h	2006-07-17 22:33:06.000000000 -0700
@@ -107,6 +107,7 @@
 	FmgrInfo	ambeginscan;
 	FmgrInfo	amgettuple;
 	FmgrInfo	amgetmulti;
+	FmgrInfo	amgetbitmapwords;
 	FmgrInfo	amrescan;
 	FmgrInfo	amendscan;
 	FmgrInfo	ammarkpos;
diff -Naur src.pgsql/include/utils/selfuncs.h src.bizgres/include/utils/selfuncs.h
--- src.pgsql/include/utils/selfuncs.h	2006-07-17 17:05:18.000000000 -0700
+++ src.bizgres/include/utils/selfuncs.h	2006-07-17 22:33:06.000000000 -0700
@@ -170,5 +170,6 @@
 extern Datum hashcostestimate(PG_FUNCTION_ARGS);
 extern Datum gistcostestimate(PG_FUNCTION_ARGS);
 extern Datum gincostestimate(PG_FUNCTION_ARGS);
+extern Datum bmcostestimate(PG_FUNCTION_ARGS);
 
 #endif   /* SELFUNCS_H */
